// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "MyGraf.h"
#include "DlgProxy.h"
#include "MyGrafDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyGrafDlgAutoProxy

IMPLEMENT_DYNCREATE(CMyGrafDlgAutoProxy, CCmdTarget)

CMyGrafDlgAutoProxy::CMyGrafDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CMyGrafDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CMyGrafDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CMyGrafDlgAutoProxy::~CMyGrafDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CMyGrafDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CMyGrafDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CMyGrafDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CMyGrafDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CMyGrafDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IMyGraf to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {4100281F-F3EE-45F5-B2FB-0AE687B34DEE}
static const IID IID_IMyGraf =
{ 0x4100281f, 0xf3ee, 0x45f5, { 0xb2, 0xfb, 0xa, 0xe6, 0x87, 0xb3, 0x4d, 0xee } };

BEGIN_INTERFACE_MAP(CMyGrafDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CMyGrafDlgAutoProxy, IID_IMyGraf, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {8F2657C0-A229-4132-BC24-16A24A1C52C6}
IMPLEMENT_OLECREATE2(CMyGrafDlgAutoProxy, "MyGraf.Application", 0x8f2657c0, 0xa229, 0x4132, 0xbc, 0x24, 0x16, 0xa2, 0x4a, 0x1c, 0x52, 0xc6)

/////////////////////////////////////////////////////////////////////////////
// CMyGrafDlgAutoProxy message handlers
