// GRAF.h: interface for the GRAF class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAF_H__04CB6890_B5B9_4F24_8D63_B094A2031F81__INCLUDED_)
#define AFX_GRAF_H__04CB6890_B5B9_4F24_8D63_B094A2031F81__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <math.h>
struct NODE
{
	int ID;   // 
	int cx,cy; // 
	int nearNodeCount;	//   
	int nearNode[100];	//   ID  
	double NodeLength;	//  .   
	bool nodeMark; //  
};

struct Path
{
	int id; // id 
};

class GRAF  
{
public:
	GRAF();
	Path *PP;
	NODE *NN;
	virtual ~GRAF();
	int nodeCount; //  
	int pathCount; //  



/*** /    ***/    

	//   
	int SaveLabirint(NODE *NN, CString file)
	{
		int nums, numwritten;
		FILE *stream;
		int *list;
		if( (stream  = fopen(file, "w+t")) == NULL )
			return 0;
		else
		{
			list = new int [1000];
			list[0] = nodeCount;

			nums = 3 * nodeCount + 1;

			for(int i = 0; i < nodeCount; i++)
			{
				list[i + 1]=(int)NN[i].cx;
				list[i + nodeCount + 1]=(int)NN[i].cy;
				list[2 * nodeCount + i + 1]=NN[i].nearNodeCount;

				for(int j = 0; j < NN[i].nearNodeCount; j++)
				{
					list[nums]=NN[i].nearNode[j];
					nums++;
				}
			}
			numwritten = fwrite(list, sizeof(int), nums, stream);
			fclose(stream);
			return 1;
		}
	}

	//   
	int LoadLabirint(NODE *NN, CString file)
	{
		CString  sss, sm;
		FILE *stream;
		int list[1000];
		if( (stream  = fopen(file, "r")) == NULL ) 
			return -1;	
		else
		{
			fread(list, sizeof(int), 1, stream);
			nodeCount = list[0];

			fread(list, sizeof(int), nodeCount * 3, stream);
			for(int i = 0; i < nodeCount; i++)
			{
				NN[i].cx = list[i];
				NN[i].cy = list[i+nodeCount];
				NN[i].ID = i;
				NN[i].nearNodeCount = list[i + nodeCount * 2];
			}
			for (i = 0; i < nodeCount; i++)
			{
				fread(list, sizeof(int), NN[i].nearNodeCount, stream);
				for(int j = 0; j < NN[i].nearNodeCount; j++)
				{
					NN[i].nearNode[j] = list[j];
				}
			}
			fclose(stream);
			pathCount=0;
			return nodeCount;
		}	
	}
/***---***/


/***  , ,  ***/

	// 
	void DrawLabirint (CDC *dc, NODE *NN, Path *RR)
	{
		int pID = 1; // id (  )

		//  
		for (int i = 0; i < nodeCount; i++)
			for (int j = 0; j < NN[i].nearNodeCount; j++)
				DrawRelation(dc, NN, NN[i].nearNode[j], i);

		//  
		for (i=0; i<pathCount; i++)
		{
			DrawRelation(dc, NN, PP[i].id, pID, 1);
			pID=PP[i].id;
		}

		// 
		for (i=0; i<nodeCount; i++)
			DrawNode(dc, NN[i].cx, NN[i].cy, i, 1);
	}
	
	//    (  )
	// return:	1- , 0 -      .
	// mode:	0-    ;  1-  ; 2-    .
	int DrawNode (CDC *dc, int x, int y, int id = -1, int mode = 0)
	{		
		if (Node_Exists(NN, x, y, 1) == -1 || mode > 0)
		{
			int Radius = 10;
			CPen pen, pen1;

			if		(nodeCount == 0 || id == 0)	pen.CreatePen(0xFF, 4, RGB(0, 0, 255));
			else if (nodeCount == 1 || id == 1)	pen.CreatePen(0xFF, 4, RGB(0, 255, 0));
			else							    pen.CreatePen(0xFF, 3, RGB(255, 0, 0));

			dc->SelectObject(&pen);

			if (mode == 2)
			{
				pen1.CreatePen(0xFF, 5, RGB(15, 255, 15));
				Radius = 3;
				dc->SelectObject(&pen1);
			}
			dc->Ellipse(x-Radius, y-Radius, x+Radius, y+Radius);
			return 1;
		}
		return 0;
	}
	
	//  
	//mode:	0-;  1-
	void DrawRelation (CDC *dc, NODE *NN, int id1, int id2, int mode=0)
	{
		CPen pen;

		if (mode == 0)	pen.CreatePen(0xFF, 4, RGB(0,255,0));
		else			pen.CreatePen(0xFF, 4, RGB(0,0,255));

		dc->SelectObject(&pen);

		dc->MoveTo(NN[id1].cx, NN[id1].cy);
		dc->LineTo(NN[id2].cx, NN[id2].cy);

		DrawNode(dc, NN[id1].cx, NN[id1].cy, id1, 1);
		DrawNode(dc, NN[id2].cx, NN[id2].cy, id2, 1);
	}


/***    ***/
	
	//  
	void addNode(NODE *NN, int x, int y)
	{	
		NN[nodeCount].cx = x;
		NN[nodeCount].cy = y;
		NN[nodeCount].ID = nodeCount;
		NN[nodeCount].nearNodeCount = 0;
		NN[nodeCount].nodeMark = 0;
		nodeCount++;
	}
	
	// 
	void addRelation(NODE *NN, int id1, int id2)
	{
		NN[id1].nearNode[NN[id1].nearNodeCount] = id2;
		NN[id2].nearNode[NN[id2].nearNodeCount] = id1;
		NN[id1].nearNodeCount++;
		NN[id2].nearNodeCount++;
	}

/***---***/	


/***    ***/	

	//   (    Path), 
	//  ...
	// return:	>0    .
	//			0 -  ...
	double SearchPath(NODE *NN, Path *RR)
	{
		if (nodeCount>0)
		{
			//""  .
			for (int i=0; i < nodeCount; i++)
			{
				NN[i].nodeMark=0;
				if (i!=0) NN[i].NodeLength = 10000;
				else NN[0].NodeLength = 0;
			} 
			PP[0].id=0;
			pathCount=0;
			//--
			
			Perekrestok(NN, 0);
			ObrHod(NN, PP, 1);
			return NN[1].NodeLength;
		}
		else return 0;
	}
	
	//     ,       
	//      (      
	//    ). 
	void Perekrestok(NODE *NN, int id)
	{
		double minLength=10000;
		
		for (int i = 0; i < NN[id].nearNodeCount; i++)
		{
			if ((getLenght(NN, NN[id].nearNode[i], id) + NN[id].NodeLength) < NN[NN[id].nearNode[i]].NodeLength)
			{
				NN[NN[id].nearNode[i]].NodeLength = (getLenght(NN, NN[id].nearNode[i], id) + NN[id].NodeLength);
				nePerekrestok(NN, NN[id].nearNode[i]);
			}
		}
	}
	
	//      (..   )     
	//   .    ,   Perekrestok.
	void nePerekrestok(NODE *NN, int id)
	{
		int nextID=-1;
		int NextPerekrestok=-1;
		double m;
		
		if (NN[id].nearNodeCount>=2)
		{
			NextPerekrestok=id;
			Perekrestok(NN, NextPerekrestok);
		}
		if (NextPerekrestok==-1)
		{
			for (int i = 0; i < NN[id].nearNodeCount; i++)
			{
				m=(getLenght(NN, NN[id].nearNode[i], id) + NN[id].NodeLength);
				if (m < NN[NN[id].nearNode[i]].NodeLength)
				{
					NN[NN[id].nearNode[i]].NodeLength = m;
					if (NN[NN[id].nearNode[i]].nearNodeCount<2) nextID=NN[id].nearNode[i];
				}
			}
		}
		
		if (NextPerekrestok==-1 && nextID!=-1)	nePerekrestok(NN, nextID);
	}
	
	//      . 
	//     ,         .
	void ObrHod(NODE *NN, Path *RR, int id)
	{
		double minLength=10000, testlength;
		int minID=0;
		
		for (int i = 0; i < NN[id].nearNodeCount; i++)
		{
			testlength = NN[id].NodeLength-NN[NN[id].nearNode[i]].NodeLength;
			
			if (minLength > testlength && testlength>0 && NN[NN[id].nearNode[i]].nodeMark!=1
				&& testlength-0.001<=getLenght(NN, NN[id].nearNode[i], id) && testlength+0.001>=getLenght(NN, NN[id].nearNode[i], id)) 
			{
				minLength=testlength;
				minID=NN[id].nearNode[i];
			}
		}
		NN[id].nodeMark=1;
		
		addPath(RR, minID);
		if (minID!=0) ObrHod(NN, RR, minID);
	}

	//     .
	double getLenght(NODE *NN, int id1, int id2)
	{
		double lenght = sqrt((NN[id1].cx - NN[id2].cx)*(NN[id1].cx - NN[id2].cx) + 
			        	(NN[id1].cy - NN[id2].cy)*(NN[id1].cy - NN[id2].cy));
		return lenght;
	}
	
	//    
	void addPath(Path *RR, int id)
	{
		RR[pathCount].id = id;
		pathCount++;
	}

/*** --- ***/

/***   ***/

	//      .
	//mode:		0-  ;  1-   ,       .
	//return:	-1 - ; >=0-     ,
	int Node_Exists (NODE *NN, int x, int y, int mode=0)
	{
		int Radius=100;
		if (mode==1)	Radius=500;
		
		for (int i=0; i<nodeCount; i++)
				if(((x - NN[i].cx)*(x - NN[i].cx) + (y - NN[i].cy)*(y - NN[i].cy)) < Radius)
					return i;
		
		return -1;
	}

	//      .
	//return:	0 - ; 1 - .
	int Relation_Exists (NODE *NN, int id1, int id2)
	{		
		for (int i=0; i<NN[id1].nearNodeCount; i++)
			if(NN[id1].nearNode[i]==id2)
				return 1;
			
		return 0;
	}

/*** --- ***/


};

#endif // !defined(AFX_GRAF_H__04CB6890_B5B9_4F24_8D63_B094A2031F81__INCLUDED_)
