// MyGrafDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyGraf.h"
#include "MyGrafDlg.h"
#include "DlgProxy.h"
#include "GRAF.h"
#include <fcntl.h>
#include <windows.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyGrafDlg dialog

IMPLEMENT_DYNAMIC(CMyGrafDlg, CDialog);

CMyGrafDlg::CMyGrafDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyGrafDlg::IDD, pParent)
{

	firstId=-1;
	modeNode = 0;
	modeRel = 0;
	GG.nodeCount = 0;
	GG.pathCount = 0;

	//{{AFX_DATA_INIT(CMyGrafDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
}

CMyGrafDlg::~CMyGrafDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CMyGrafDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyGrafDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyGrafDlg, CDialog)
	//{{AFX_MSG_MAP(CMyGrafDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton_SaveLabirint)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton_LoadLabirint)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, On_ReloadLabirint)
	ON_BN_CLICKED(IDC_BUTTON9, On_Clear_Labirint)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyGrafDlg message handlers

BOOL CMyGrafDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyGrafDlg::OnPaint() 
{
	CDC *dc=GetDC();
	dc->Rectangle(15,11,395,408);

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
		
			dc.SetBkColor(RGB(255,0,0));
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyGrafDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CMyGrafDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CMyGrafDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void CMyGrafDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CMyGrafDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

//   - check
void CMyGrafDlg::OnButton1() 
{
	if(modeNode == 0)
	{
		modeNode=1;
		SetDlgItemText(IDC_BUTTON1," ");

		modeRel = 0;
		SetDlgItemText(IDC_BUTTON2," ");
	}
	else
	{
		modeNode=0;
		SetDlgItemText(IDC_BUTTON1," ");
	}	
}

//   - check
void CMyGrafDlg::OnButton2() 
{
	if(modeRel == 0)
	{
		modeNode=0;
		SetDlgItemText(IDC_BUTTON1," ");
		
		modeRel = 1;
		SetDlgItemText(IDC_BUTTON2,"");
	}
    else
	{
		modeRel = 0;
		SetDlgItemText(IDC_BUTTON2," ");
	}
	
				
}

//     .
void CMyGrafDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDC *dc=GetDC();

	if(modeNode == 1)
	{
		if(point.x > 23 && point.y > 23 && point.x < 390 && point.y < 395)
		{
			if ( (GG.DrawNode(dc, point.x, point.y, GG.nodeCount))==1 )
				GG.addNode(GG.NN, point.x, point.y);
		}
	}
	else if(modeRel == 1)
	{
		id=GG.Node_Exists(GG.NN, point.x, point.y);
		if ( id >= 0)
		{
			if (firstId==-1)
			{
				GG.DrawNode(dc,GG.NN[id].cx,GG.NN[id].cy,id,2);
				firstId = id;
			}

			if (firstId!=id && firstId>=0)
			{
				if (GG.Relation_Exists(GG.NN, firstId, id)==0)
				{
					GG.DrawRelation(dc, GG.NN, firstId, id);
					GG.addRelation(GG.NN, firstId, id);
				}
				else
				{
					GG.DrawNode(dc,GG.NN[firstId].cx,GG.NN[firstId].cy,firstId,1);
					/*CString yyyy;
					yyyy.Format("  ...");
					AfxMessageBox(yyyy);*/
				}
				firstId=-1;
			}
		}
		else
		{
			if (firstId!=-1)
			{
				GG.DrawNode(dc,GG.NN[firstId].cx,GG.NN[firstId].cy,firstId,1);
			}
			firstId=-1;
		}
	}
	

	CDialog::OnLButtonDown(nFlags, point);
}

// " ".
void CMyGrafDlg::OnButton3() 
{
	CDC *dc=GetDC();
	CString mess;
	double minpath=0;

	UpdateData(true);
	
	minpath=GG.SearchPath(GG.NN, GG.PP);

	GG.DrawLabirint(dc, GG.NN, GG.PP);
	
	if(GG.NN[1].NodeLength < 10000 && minpath>0)	mess.Format("%lf", minpath);
	else mess.Format("  !");
	
	SetDlgItemText(IDC_EDIT1,mess);
}

// 
void CMyGrafDlg::OnButton_SaveLabirint() 
{
	CFileDialog dlg(true);
	CString mess;

	if(dlg.DoModal()!=IDOK) return;

	if ( (GG.SaveLabirint(GG.NN, dlg.GetPathName()))==1 )	mess.Format("  !");
	else	mess.Format("  .");
}

// 
void CMyGrafDlg::OnButton_LoadLabirint() 
{
	CFileDialog dlg(true);
	CDC *dc=GetDC();
	CString mess;

	if(dlg.DoModal()!=IDOK) return;
	dc->Rectangle(15,11,395,408);

	if ( (GG.LoadLabirint(GG.NN, dlg.GetPathName())) == -1 )
	{
		mess.Format("  .");
		AfxMessageBox(mess);
	}
	else GG.DrawLabirint(dc, GG.NN, GG.PP);

	SetDlgItemText(IDC_EDIT1,"");
}

// R -  
void CMyGrafDlg::On_ReloadLabirint() 
{
	CString mess;
	CDC *dc=GetDC();
	
	GG.DrawLabirint(dc, GG.NN, GG.PP);
}

// C -  .  .
void CMyGrafDlg::On_Clear_Labirint() 
{
	CDC *dc=GetDC();
	
	GG.nodeCount = 0;
	GG.pathCount = 0;
	
	SetDlgItemText(IDC_EDIT1,"");
	
	dc->Rectangle(15,11,395,408);
	
}

void CMyGrafDlg::OnButton6() 
{
	CString yyyy,sm;
	yyyy.Format("nodeCount: %d\n", GG.nodeCount);
	sm.operator+=(yyyy);
	for (int i=0; i<GG.nodeCount; i++)
	{
		//yyyy.Format("%d (%d;%d), nearNodeCount: %d; nodeMark: %d; nodeLength:%lf\n", i, GG.NN[i].cx, GG.NN[i].cy,  GG.NN[i].nearNodeCount, GG.NN[i].nodeMark, GG.NN[i].NodeLength);
		sm.operator+=(yyyy);
		for (int j=0; j<GG.NN[i].nearNodeCount; j++)
		{
			yyyy.Format("- %d, nearNode: %d:\n", i, GG.NN[i].nearNode[j]);
			sm.operator+=(yyyy);
		}
	}
	AfxMessageBox(sm);
}

void CMyGrafDlg::OnButton7() 
{

}

void CMyGrafDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here

}
